OrderedCollections.jl
=====================

[![CI](https://github.com/JuliaCollections/OrderedCollections.jl/workflows/CI/badge.svg)](https://github.com/JuliaCollections/OrderedCollections.jl/actions?query=workflow%3ACI)
[![Test Coverage](https://codecov.io/github/JuliaCollections/OrderedCollections.jl/coverage.svg?branch=master)](https://codecov.io/github/JuliaCollections/OrderedCollections.jl?branch=master)
[![Documentation (dev)](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliacollections.github.io/OrderedCollections.jl/dev)
[![Documentation (stable)](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliacollections.github.io/OrderedCollections.jl/stable)

This package implements OrderedDicts and OrderedSets, which are similar to containers in base Julia.
However, during iteration the Ordered* containers return items in the order in which they were added to the collection.
It also implements `LittleDict` which is a ordered dictionary, that is much faster than any other `AbstractDict` (ordered or not) for small collections.

This package was split out from [DataStructures.jl](https://github.com/JuliaCollections/DataStructures.jl).

module OrderedCollections

    import Base: <, <=, ==, convert, length, isempty, iterate, delete!,
                 show, dump, empty!, getindex, setindex!, get, get!,
                 in, haskey, keys, merge, copy, cat,
                 push!, pop!, popfirst!, insert!,
                 union!, delete!, empty, sizehint!,
                 isequal, hash,
                 map, map!, reverse,
                 first, last, eltype, getkey, values, sum,
                 merge, merge!, mergewith, lt, Ordering, ForwardOrdering, Forward,
                 ReverseOrdering, Reverse, Lt,
                 isless,
                 union, intersect, symdiff, setdiff, setdiff!, issubset,
                 searchsortedfirst, searchsortedlast, in,
                 filter, filter!, ValueIterator, eachindex, keytype,
                 valtype, lastindex, nextind,
                 copymutable, emptymutable, dict_with_eltype

    export OrderedDict, OrderedSet, LittleDict, LittleSet
    export freeze

    include("dict_support.jl")
    include("ordered_dict.jl")
    include("little_dict.jl")
    include("little_set.jl")
    include("ordered_set.jl")
    include("dict_sorting.jl")

    import Base: similar
    @deprecate similar(d::OrderedDict) empty(d)
    @deprecate similar(s::OrderedSet) empty(s)
end

const StoreType{T} = Union{Tuple{Vararg{T}}, AbstractVector{T}}

@noinline function _throw_unequal_lengths(nk::Int, nv::Int)
    throw(ArgumentError("Number of keys ($nk) differs from number of values ($nv)."))
end

"""
    LittleDict(keys, vals) <: AbstractDict

An ordered dictionary type for small numbers of keys.
Rather than using `hash` or some other sophisticated measure
to store the vals in a clever arrangement,
it just keeps everything in a pair of lists.

While theoretically this has expected time complexity _O(n)_
(vs the hash-based [`OrderedDict`](@ref)/`Dict`'s expected time complexity _O(1)_,
and the search-tree-based `SortedDict`'s expected time complexity _O(log(n))_),
in practice it is really fast, because it is cache & SIMD friendly.

It is reasonable to expect it to outperform an `OrderedDict`,
with up to around 30 elements in general;
or with up to around 50 elements if using a `LittleDict` backed by `Tuples`
(see [`freeze`](@ref))
However, this depends on exactly how long `isequal` and `hash` take,
as well as on how many hash collisions occur etc.

!!! note
    When constructing a `LittleDict` it is faster to pass in the keys and
    values each as seperate lists. So if you have them seperately already,
    do `LittleDict(ks, vs)` not `LittleDict(zip(ks, vs))`.
    Furthermore, key and value lists that are passed as `Tuple`s will not require any
    copies to create the `LittleDict`, so `LittleDict(ks::Tuple, vs::Tuple)`
    is the fastest constructor of all.
"""
struct LittleDict{K, V, KS<:StoreType{K}, VS<:StoreType{V}} <: AbstractDict{K, V}
    keys::KS
    vals::VS

    function LittleDict{K, V, KS, VS}(keys, vals) where {K, V, KS, VS}
        nk = length(keys)
        nv = length(vals)
        nk == nv || _throw_unequal_lengths(Int(nk), Int(nv))
        return new{K, V, KS, VS}(keys, vals)
    end
    LittleDict{K, V, <:Tuple, <:Tuple}() where {K, V} = new{K, V, Tuple{}, Tuple{}}((), ())
    LittleDict{K, V, KS, VS}() where {K, V, KS, VS} = LittleDict{K, V, KS, VS}(KS(), VS())
end
LittleDict{K, V, KS, VS}(d::AbstractDict) where {K, V, KS<:StoreType{K}, VS<:StoreType{V}} = LittleDict{K, V, KS, VS}(collect(keys(d)), collect(values(d)))

function LittleDict{K,V}(ks::KS, vs::VS) where {K,V, KS<:StoreType,VS<:StoreType}
    return LittleDict{K, V, KS, VS}(ks, vs)
end

function LittleDict(ks::KS, vs::VS) where {KS<:StoreType,VS<:StoreType}
    return LittleDict{eltype(KS), eltype(VS)}(ks, vs)
end

# Other iterators should be copied to a Vector
LittleDict(ks, vs) = LittleDict(collect(ks), collect(vs))

function LittleDict{K, V}(itr) where {K,V}
    ks = K[]
    vs = V[]
    for val in itr
        if !(val isa Union{Tuple{Any, Any}, Pair})
            throw(ArgumentError(
                "LittleDict(kv): kv needs to be an iterator of tuples or pairs")
            )
        end
        k, v = val
        push!(ks, k)
        push!(vs, v)
    end
    return LittleDict(ks, vs)
end

LittleDict{K,V}(itr...) where {K,V} = LittleDict{K,V}(itr)
LittleDict(itr...) = LittleDict(itr)
LittleDict(itr::T) where T = LittleDict{kvtype(eltype(T))...}(itr)

# Avoid contention between the core constructor, and the list of elements
LittleDict(itr1::Pair, itr2::Pair) = LittleDict(first.([itr1, itr2]), last.([itr1,itr2]))
LittleDict(itr1::Pair) = LittleDict([first(itr1)], [last(itr1)])
LittleDict{K, V}(itr::Pair) where {K, V} = LittleDict{K,V}(K[first(itr)], V[last(itr)])

kvtype(::Any) = (Any, Any)
kvtype(::Type{Union{}}) = (Any,Any)

kvtype(::Type{Pair{K,V}}) where {K,V} = (K,V)
kvtype(::Type{Pair{<:Any,V}}) where {V} = (Any,V)
kvtype(::Type{Pair{K,<:Any}}) where {K} = (K,Any)

kvtype(::Type{Tuple{K,V}}) where {K,V} = (K,V)

"""
    freeze(dd::AbstractDict)

Render a dictionary immutable by converting it to a `Tuple`-backed
`LittleDict`.
The `Tuple`-backed `LittleDict` is faster than the `Vector`-backed `LittleDict`,
particularly when the keys are all concretely typed.
"""
function freeze(dd::AbstractDict)
    ks = Tuple(keys(dd))
    vs = Tuple(values(dd))
    return LittleDict(ks, vs)
end

isordered(::Type{<:LittleDict}) = true

# For now these are internal UnionAlls for dispatch purposes
const UnfrozenLittleDict{K, V} = LittleDict{K, V, <:AbstractVector{K}, <:AbstractVector{V}}
const FrozenLittleDict{K, V} = LittleDict{K, V, <:Tuple, <:Tuple}

##### Methods that all AbstractDicts should implement

Base.length(dd::LittleDict) = length(dd.keys)

function Base.getkey(dd::LittleDict, key, default)
    if key ∈ dd.keys
        return key
    else
        return default
    end
end

function Base.map!(f, iter::Base.ValueIterator{<:LittleDict})
    dict = iter.dict
    vals = dict.vals
    for i in 1:length(vals)
        @inbounds vals[i] = f(vals[i])
    end
    return iter
end

function Base.get(dd::LittleDict, key, default)
    @assert length(dd.keys) == length(dd.vals)
    for ii in 1:length(dd.keys)
        cand = @inbounds dd.keys[ii]
        isequal(cand, key) && return @inbounds(dd.vals[ii])
    end
    return default
end
function get(default::Base.Callable, dd::LittleDict, key)
    got = get(dd, key, NotFoundSentinel())
    if got isa NotFoundSentinel  # not found
        return default()
    else
        return got
    end
end

function Base.iterate(dd::LittleDict, ii=1)
    ii > length(dd.keys) && return nothing
    return (dd.keys[ii] => dd.vals[ii], ii+1)
end

# lazy reverse iteration
function Base.iterate(rdd::Iterators.Reverse{<:LittleDict}, ii=length(rdd.itr.keys))
    dd = rdd.itr
    ii < 1 && return nothing
    return (dd.keys[ii] => dd.vals[ii], ii-1)
end

function merge(d1::LittleDict, others::AbstractDict...)
    return merge((x,y)->y, d1, others...)
end

function mergewith(
    combine,
    d::LittleDict,
    others::AbstractDict...
    )
    K,V = _merge_kvtypes(d, others...)
    dc = LittleDict{K,V}(d)
    for d2 in others
        for (k2,v2) in d2
            got = get(dc, k2, NotFoundSentinel())
            if got isa NotFoundSentinel
                add_new!(dc, k2, v2)
            else
                # GOLDPLATE: ideally we would avoid iterating this twice
                # once for get and once for setindex!
                dc[k2]=combine(got, v2)
            end
        end
    end
    return dc
end

merge(combine::Function, d::LittleDict, others::AbstractDict...) = mergewith(combine, d, others...)

function Base.empty(dd::LittleDict{K,V}) where {K,V}
    LittleDict{K, V}(empty(getfield(dd, :keys)), empty(getfield(dd, :vals)))
end

######## Methods that all mutable AbstractDict's should implement

function Base.sizehint!(dd::UnfrozenLittleDict, sz::Integer)
    sizehint!(dd.keys, sz)
    sizehint!(dd.vals,sz)
    return dd
end

function add_new!(dd::UnfrozenLittleDict{K, V}, key, value) where {K, V}
    kk = convert(K, key)
    vv = convert(V, value)

    # if we can convert it to the right type, and the dict is unfrozen
    # then neither push can fail, so the dict length will remain in sync
    push!(dd.keys, kk)
    push!(dd.vals, vv)

    return dd
end

function Base.setindex!(dd::LittleDict{K,V, <:Any, <:Vector}, value, key) where {K,V}
    # Note we only care if the Value store is mutable (<:Vector)
    # As we can have immutable keys, if we are setting the value of an existing key

    # Assertion below commented out as by standards of carefully optimised
    # setindex! it has huge code (26%), this does mean that if someone has messed
    # with the fields of the LittleDict directly, then the @inbounds could be invalid
    #@assert length(dd.keys) == length(dd.vals)

    kk = convert(K, key)
    vv = convert(V, value)
    for ii in 1:length(dd.keys)
        cand = @inbounds dd.keys[ii]
        if isequal(cand, kk)
            @inbounds(dd.vals[ii] = vv)
            return dd
        end
    end
    add_new!(dd, key, value)
    return dd
end

function Base.pop!(dd::UnfrozenLittleDict)
    pop!(dd.keys)
    return pop!(dd.vals)
end

function Base.pop!(dd::UnfrozenLittleDict, key)
    @assert length(dd.keys) == length(dd.vals)

    for ii in 1:length(dd.keys)
        cand = @inbounds dd.keys[ii]
        if isequal(cand, key)
            deleteat!(dd.keys, ii)
            val = @inbounds dd.vals[ii]
            deleteat!(dd.vals, ii)
            return val
        end
    end
end

function Base.delete!(dd::UnfrozenLittleDict, key)
    pop!(dd, key)
    return dd
end

Base.empty!(dd::UnfrozenLittleDict) = (empty!(dd.keys); empty!(dd.vals); dd)

function get!(default::Base.Callable, dd::UnfrozenLittleDict, key)
    got = get(dd, key, NotFoundSentinel())
    if got isa NotFoundSentinel  # not found
        val = default()
        add_new!(dd, key, val)
        return val
    else
        return got
    end
end
get!(dd::UnfrozenLittleDict, key, default) = get!(()->default, dd, key)

using OrderedCollections
using Test
using Random, Serialization

@test isempty(detect_ambiguities(Base, Core, OrderedCollections))

tests = [
         "little_dict",
         "little_set",
         "ordered_dict",
         "ordered_set",
        ]

if length(ARGS) > 0
    tests = ARGS
end

@testset "OrderedCollections" begin

for t in tests
    fp = joinpath(dirname(@__FILE__), "test_$t.jl")
    println("$fp ...")
    include(fp)
end

end # @testset

using Documenter
using OrderedCollections

makedocs(
	modules = [OrderedCollections],
	sitename = "OrderedCollections.jl",
    pages = [
        "index.md",
    ]
)

deploydocs(
    repo = "github.com/JuliaCollections/OrderedCollections.jl.git",
    push_preview = true,
)

"""
    LittleSet([itr]) <: AbstractSet

Constructs an ordered set optimized for a small number of elements, given the
iterable `itr`. The underlying data is stored as either an `AbstractVector` or
a `Tuple` and is optimal for 30-50 elements, similar to [`LittleDict`](@ref).
"""
struct LittleSet{T, D<:StoreType{T}} <: AbstractSet{T}
    data::D

    LittleSet{T, D}(data) where {T,D} = new{T, D}(data)
    function LittleSet{T, Tuple{Vararg{T}}}(@nospecialize(data)) where {T}
        new_data = isa(data, Tuple) ? data : Tuple(data)
        new{T, Tuple{Vararg{T}}}(new_data)
    end
    function (LittleSet{T, Tuple{Vararg{T}}} where {T})(@nospecialize(data))
        T2 = eltype(data)
        new{T2, Tuple{Vararg{T2}}}(data)
    end
    function LittleSet{T}(data::AbstractVector) where {T}
        if eltype(data) == T
            return new{T, typeof(data)}(data)
        else
            d = convert(AbstractVector{T}, data)
            return new{T, typeof(d)}(d)
        end
    end
    LittleSet{T}(data::Tuple{Vararg{T}}) where {T} = new{T, typeof(data)}(data)
    LittleSet{T}(itr) where {T} = union!(LittleSet{T}(), itr)
    LittleSet{T}() where {T} = new{T, Vector{T}}(Vector{T}())
    LittleSet() = LittleSet{Any}()
    function LittleSet(itr)
        IET = Base.IteratorEltype(itr)
        if isa(IET, Base.HasEltype)
            LittleSet{eltype(itr)}(itr)
        else
            T = Base.@default_eltype(itr)
            if (Base.isconcretetype(T) || T === Union{})
                return LittleSet{T}(itr)
            else
                return Base.grow_to!(LittleSet{T}(), itr)
            end
        end
    end

    function Base.empty(s::LittleSet{T, D}) where {T, D}
        if isa(s, LittleSet{T, Tuple{Vararg{T}}})
            return new{T, Tuple{Vararg{T}}}(())
        elseif D <: Tuple
            return new{T, Tuple{}}(())
        else
            return new{T, D}(empty(getfield(s, :data)))
        end
    end
    function Base.emptymutable(s::LittleSet{T, D}, ::Type{U}=T) where {T, D, U}
        if D <: Tuple
            new_data = U[]
        else
            new_data = Base.emptymutable(getfield(s, :data), U)
        end
        return new{U, typeof(new_data)}(new_data)
    end
end

const OpaqueLittleSet{T} = LittleSet{T, Tuple{Vararg{T}}}
const UnfrozenLittleSet{T} = LittleSet{T, <:AbstractVector{T}}
const FrozenLittleSet{T} = LittleSet{T, <:Tuple}

function Base.Tuple(s::LittleSet)
    data = getfield(s, :data)
    isa(data, Tuple) ? data : Tuple(data)
end

freeze(s::AbstractSet{T}) where {T} = LittleSet{T}(Tuple(s))

hash(s::LittleSet, h::UInt) = hash(getfield(s, :data), hash(orderedset_seed, h))

function Base.length(s::LittleSet)
    data = getfield(s, :data)
    isa(data, Tuple) ? nfields(data) : length(data)
end

function Base.isempty(s::LittleSet)
    data = getfield(s, :data)
    isa(data, Tuple) ? nfields(data) == 0 : isempty(data)
end

function Base.copy(s::LittleSet{T, D}) where {T, D}
    # since `Base.copy` is a shallow copy on collections, an immutable collection
    # like `Tuple` is treated the same
    if D <: Tuple
        return s
    else
        return LittleSet{T, D}(copy(getfield(s, :data)))
    end
end

function Base.copymutable(s::LittleSet{T}) where {T}
    data = getfield(s, :data)
    if isa(data, Tuple)
        i = nfields(data)
        new_data = Vector{T}(undef, n)
        while i != 0
            @inbounds new_data[i] = getfield(data, i)
            i -= 1
        end
    else
        new_data = Base.copymutable(data)
    end
    LittleSet{T}(new_data)
end

function Base.sizehint!(s::UnfrozenLittleSet, sz::Integer)
    sizehint!(getfield(s, :data), sz)
    return s
end
Base.iterate(s::LittleSet, state...) = iterate(getfield(s, :data), state...)

function Base.in(x, s::LittleSet)
    data = getfield(s, :data)
    if isa(data, Tuple)
        n = nfields(data)
        while n > 0
            isequal(x, getfield(data, n)) && return true
            n -= 1
        end
        return false
    else
        return in(x, data)
    end
end

# HACK: this is a temporary hack to get around the lack of `sort` available for tuples
function Base.sort(s::FrozenLittleSet{T}; ks...) where {T}
    LittleSet{T}(sort(T[getfield(s, :data)...]; ks...))
end
function Base.sort(s::UnfrozenLittleSet{T}; ks...) where {T}
    LittleSet{T}(sort(getfield(s, :data); ks...))
end

function Base.sort!(s::UnfrozenLittleSet; ks...)
    sort!(getfield(s, :data); ks...)
    return s
end

Base.first(s::UnfrozenLittleSet, n::Integer) = LittleSet(first(getfield(s, :data), n))
function Base.first(s::FrozenLittleSet{T}, n::Integer) where {T}
    N = Int(n)
    N < 0 && throw(ArgumentError("Number of elements must be nonnegative"))
    data = getfield(s, :data)
    stop = nfields(data)
    if stop <= N
        # max number of elements is everything so it's equivalent to `copy`
        return s
    elseif isa(s, LittleSet{T, Tuple{Vararg{T}}})
        return LittleSet{T, Tuple{Vararg{T}}}(Tuple(@inbounds(collect(data)[1:N])))
    else
        return LittleSet{T}(ntuple(i->getfield(data, i), min(nfields(data), n)))
    end
end

Base.last(s::UnfrozenLittleSet, n::Integer) = LittleSet(last(getfield(s, :data), n))
function Base.last(s::FrozenLittleSet{T}, n::Integer) where {T}
    N = Int(n)
    N < 0 && throw(ArgumentError("Number of elements must be nonnegative"))
    data = getfield(s, :data)
    stop = nfields(data)
    offset = stop - N
    if offset < 1
        # offset less than one means each element is returned so it's equivalent to `copy`
        return s
    elseif isa(s, LittleSet{T, Tuple{Vararg{T}}})
        return LittleSet{T, Tuple{Vararg{T}}}(Tuple(@inbounds(collect(data)[1:N])))
    else
        return LittleSet{T}(ntuple(i->getfield(data, offset + i), N))
    end
end

function Base.union(x::FrozenLittleSet{T1}, y::FrozenLittleSet{T2}) where {T1, T2}
    xdata = getfield(x, :data)
    nx = nfields(xdata)
    ydata = getfield(y, :data)
    ny = nfields(ydata)
    if isa(x, LittleSet{T1, Tuple{Vararg{T1}}}) || isa(y, LittleSet{T2, Tuple{Vararg{T2}}})
        if nx < ny # nx is smaller so search for x items in y
            newdata = (filter(!in(y), x)..., ydata...)
        else # ny is smaller so search for y items in x
            newdata = (xdata..., getfield(filter(!in(x), y), :data)...)
        end
        T = Union{T1, T2}
        return LittleSet{T, Tuple{Vararg{T}}}(newdata)
    else
        if nx < ny # nx is smaller so search for x items in y
            return LittleSet((filter(!in(ydata), xdata)..., ydata...))
        else # ny is smaller so search for y items in x
            return LittleSet((xdata..., filter(!in(xdata), ydata)...))
        end
    end
end

function Base.push!(s::UnfrozenLittleSet, val)
    data = getfield(s, :data)
    if !in(val, data)
        push!(data, val)
    end
    return s
end

Base.pop!(s::UnfrozenLittleSet) = pop!(getfield(s, :data))
function Base.pop!(s::UnfrozenLittleSet, key)
    data = getfield(s, :data)
    for i in eachindex(data)
        k = @inbounds(data[i])
        if (key ===  k || isequal(key, k))
            deleteat!(data, i)
            return k
        end
    end
    throw(KeyError(key))
end
function Base.pop!(s::UnfrozenLittleSet, key, default)
    data = getfield(s, :data)
    for i in eachindex(data)
        k = @inbounds(data[i])
        if (key ===  k || isequal(key, k))
            deleteat!(data, i)
            return k
        end
    end
    return default
end

Base.empty!(s::UnfrozenLittleSet) = (empty!(getfield(s, :data)); s)

function Base.delete!(s::UnfrozenLittleSet, key)
    data = getfield(s, :data)
    for i in eachindex(data)
        k = @inbounds(data[i])
        if (key ===  k || isequal(key, k))
            deleteat!(data, i)
            break
        end
    end
    return s
end

function Base.filter(f, s::LittleSet{T}) where {T}
    newdata = filter(f, getfield(s, :data))
    if isa(s, OpaqueLittleSet)
        return OpaqueLittleSet{T}(newdata)
    else
        return LittleSet(newdata)
    end
end
function Base.filter!(f, s::UnfrozenLittleSet)
    filter!(f, getfield(s, :data))
    return s
end

# these are copied from Julia's "base/set.jl" because tuple replace isn't
# supported before Julia v1.7
function check_count(count::Integer)
    count < 0 && throw(DomainError(count, "`count` must not be negative (got $count)"))
    return min(count, typemax(Int)) % Int
end

function Base.replace(
    s::LittleSet{T},
    old_new::Pair{F, S}...;
    count::Integer=typemax(Int)
) where {T, F, S}
    replace(s; count=count) do x
        for o_n in old_new
            isequal(first(o_n), x) && return last(o_n)
        end
        return x
    end
end
function Base.replace(
    f::Union{Function, Type},
    s::LittleSet{T, D};
    count::Integer=typemax(Int)
) where {T, D}
    old_data = getfield(s, :data)
    if isa(old_data, Tuple)
        c = check_count(count)
        n = nfields(old_data)
        v = Vector{Any}(undef, n)
        for i in Base.OneTo(n)
            old_item = @inbounds(getfield(old_data, i))
            if c > 0
                new_item = f(old_item)
                if new_item == old_item
                    c -= 1
                end
            else
                new_item = old_item
            end
            @inbounds(setindex!(v, new_item, i))
        end
        new_data = (v...,)
        T2 = eltype(new_data)
        if isa(s, LittleSet{T, Tuple{Vararg{T}}})
            return LittleSet{T2, Tuple{Vararg{T2}}}(new_data)
        else
            return LittleSet{T2, typeof(new_data)}(new_data)
        end
    else
        new_data = replace(f, old_data, count=count)
        return LittleSet(new_data)
    end
end

using OrderedCollections, Test
using OrderedCollections: FrozenLittleDict, UnfrozenLittleDict

@testset "LittleDict" begin
    @testset "Type Aliases" begin
        FF1 = LittleDict{Int,Int, NTuple{10, Int}, NTuple{10, Int}}
        @test FF1 <: FrozenLittleDict{<:Any, <:Any}
        @test FF1 <: FrozenLittleDict
        @test FF1 <: FrozenLittleDict{Int, Int}
        @test !(FF1 <: UnfrozenLittleDict{<:Any, <:Any})
        @test !(FF1 <: UnfrozenLittleDict)
        @test !(FF1 <: UnfrozenLittleDict{Int, Int})


        UU1 = LittleDict{Int,Int,Vector{Int},Vector{Int}}
        @test !(UU1 <: FrozenLittleDict{<:Any, <:Any})
        @test !(UU1 <: FrozenLittleDict)
        @test !(UU1 <: FrozenLittleDict{Int, Int})
        @test (UU1 <: UnfrozenLittleDict{<:Any, <:Any})
        @test (UU1 <: UnfrozenLittleDict)
        @test (UU1 <: UnfrozenLittleDict{Int, Int})


        FU1 = LittleDict{Int,Int,NTuple{10, Int},Vector{Int}}
        @test !(FU1 <: FrozenLittleDict{<:Any, <:Any})
        @test !(FU1 <: FrozenLittleDict)
        @test !(FU1 <: FrozenLittleDict{Int, Int})
        @test !(FU1 <: UnfrozenLittleDict{<:Any, <:Any})
        @test !(FU1 <: UnfrozenLittleDict)
        @test !(FU1 <: UnfrozenLittleDict{Int, Int})

        UF1 = LittleDict{Int,Int,Vector{Int},NTuple{10,Int}}
        @test !(UF1 <: FrozenLittleDict{<:Any, <:Any})
        @test !(UF1 <: FrozenLittleDict)
        @test !(UF1 <: FrozenLittleDict{Int, Int})
        @test !(UF1 <: UnfrozenLittleDict{<:Any, <:Any})
        @test !(UF1 <: UnfrozenLittleDict)
        @test !(UF1 <: UnfrozenLittleDict{Int, Int})
    end

    @testset "Constructors" begin
        @test isa(@inferred(LittleDict{Any, Any, <:Tuple, <:Tuple}()), LittleDict{Any, Any, Tuple{}, Tuple{}})
        @test isa(@inferred(LittleDict()), LittleDict{Any,Any})
        @test isa(@inferred(LittleDict([(1,2.0)])), LittleDict{Int,Float64})

        @test isa(@inferred(LittleDict([("a",1),("b",2)])), LittleDict{String,Int})
        @test isa(@inferred(LittleDict(Pair(1, 1.0))), LittleDict{Int,Float64})
        @test isa(@inferred(LittleDict(Pair(1, 1.0), Pair(2, 2.0))),
        LittleDict{Int,Float64})

        @test isa(@inferred(LittleDict{Int,Float64}(2=>2.0, 3=>3.0)),
            LittleDict{Int,Float64})
        @test isa(@inferred(LittleDict{Int,Float64}(Pair(1, 1), Pair(2, 2))), LittleDict{Int,Float64})
        @test isa(@inferred(LittleDict(Pair(1, 1.0), Pair(2, 2.0), Pair(3, 3.0))), LittleDict{Int,Float64})
        @test LittleDict(()) == LittleDict{Any,Any}()

        @test isa(@inferred(LittleDict([Pair(1, 1.0), Pair(2, 2.0)])), LittleDict{Int,Float64})
        @test_throws ArgumentError LittleDict([1,2,3,4])

        iter = Iterators.filter(x->x.first>1, [Pair(1, 1.0), Pair(2, 2.0), Pair(3, 3.0)])
        @test @inferred(LittleDict(iter)) == LittleDict{Int,Float64}(2=>2.0, 3=>3.0)

        iter = Iterators.drop(1:10, 1)
        @test_throws ArgumentError LittleDict(iter)

        k_iter = Iterators.filter(x->x>1, [1,2,3,4])
        v_iter = Iterators.filter(x->x>1, [1.0,2.0,3.0,4.0])
        @test @inferred(LittleDict(k_iter, v_iter)) isa
            LittleDict{Int,Float64, Vector{Int}, Vector{Float64}}

        @test @inferred(LittleDict{Int, Char}(rand(1:100,20), rand('a':'z', 20))) isa
            LittleDict{Int,Char,Vector{Int},Vector{Char}}

        # Different number of keys and values
        @test_throws ArgumentError LittleDict{Int, Char, Vector{Int}, Vector{Char}}([1,2,3], ['a','b'])
    end


    @testset "empty dictionary" begin
        d = LittleDict{Char, Int}()
        @test length(d) == 0
        @test isempty(d)
        @test_throws KeyError d['c'] == 1
        d['c'] = 1
        @test !isempty(d)
        @test_throws KeyError d[0.01]
        @test isempty(empty(d))
        empty!(d)
        @test isempty(d)
        @test delete!(d, "foo") == empty(d)  # Make sure this does't throw an error

        # access, modification
        for c in 'a':'z'
            d[c] = c - 'a' + 1
        end

        @test (d['a'] += 1) == 2
        @test 'a' in keys(d)
        @test haskey(d, 'a')
        @test get(d, 'B', 0) == 0
        @test getkey(d, 'b', nothing) == 'b'
        @test getkey(d, 'B', nothing) == nothing
        @test !('B' in keys(d))
        @test !haskey(d, 'B')
        @test pop!(d, 'a') == 2
        @test pop!(d) == 26  # z was added last

        @test collect(keys(d)) == collect('b':'y')
        @test collect(values(d)) == collect(2:25)
        @test collect(d) == [Pair(a,i) for (a,i) in zip('b':'y', 2:25)]
    end

    @testset "convert" begin
        d = LittleDict{Int,Float32}(i=>Float32(i) for i = 1:10)
        @test convert(LittleDict{Int,Float32}, d) === d
        dc = convert(LittleDict{Int,Float64}, d)
        @test dc !== d
        @test keytype(dc) == Int
        @test valtype(dc) == Float64
        @test keys(dc) == keys(d)
        @test collect(values(dc)) == collect(values(d))

        d = Dict(i=>Float32(i) for i = 1:10)
        @test convert(LittleDict{Int,Float32}, d) isa LittleDict{Int,Float32}
        @test convert(LittleDict{Int,Float32,Vector{Int},Vector{Float32}}, d) isa LittleDict{Int,Float32,Vector{Int},Vector{Float32}}
    end

    @testset "Issue #60" begin
        od60 = LittleDict{Int,Int}()
        od60[1] = 2

        ranges = [2:5, 6:9, 10:13]
        for range in ranges
            for i = range
                od60[i] = i+1
            end
            for i = range
                delete!( od60, i )
            end
        end
        od60[14]=15

        @test od60[14] == 15
    end


    ##############################
    # Copied and modified from Base/test/dict.jl

    # LittleDict

    @testset "LittleDict{Int,Int}" begin
        h = LittleDict{Int,Int}()
        for i=1:100
            h[i] = i+1
        end

        @test collect(h) == [Pair(x,y) for (x,y) in zip(1:100, 2:101)]

        for i=1:2:100
            delete!(h, i)
        end
        for i=1:2:100
            h[i] = i+1
        end

        for i=1:100
            @test h[i]==i+1
        end

        for i=1:100
            delete!(h, i)
        end
        @test isempty(h)

        h[77] = 100
        @test h[77]==100
        @test length(h) == 1

        for i=1:100
            h[i] = i+1
        end
        @test length(h) == 100

        for i=1:2:50
            delete!(h, i)
        end
        @test length(h) == 75

        for i=51:100
            h[i] = i+1
        end
        @test length(h) == 75

        for i=2:2:100
            @test h[i]==i+1
        end
        for i=75:100
            @test h[i]==i+1
        end
    end

    @testset "LittleDict{Any,Any}" begin
        h = LittleDict{Any,Any}([("a", 3)])
        @test h["a"] == 3
        h["a","b"] = 4
        @test h["a","b"] == h[("a","b")] == 4
        h["a","b","c"] = 4
        @test h["a","b","c"] == h[("a","b","c")] == 4
    end

    @testset "KeyError" begin
        z = LittleDict()
        get_KeyError = false
        try
            z["a"]
        catch _e123_
            get_KeyError = isa(_e123_, KeyError)
        end
        @test get_KeyError
    end

    @testset "filter" begin
        _d = LittleDict([("a", 0)])
        v = [k for k in filter(x->length(x)==1, collect(keys(_d)))]
        @test isa(v, Vector{String})
    end

    @testset "from tuple/vector/pairs/tuple of pair 1" begin
        d = LittleDict(((1, 2), (3, 4)))
        d2 = LittleDict([(1, 2), (3, 4)])
        d3 = LittleDict(1 => 2, 3 => 4)
        d4 = LittleDict((1 => 2, 3 => 4))

        @test d[1] === 2
        @test d[3] === 4

        @test d == d2 == d3 == d4
        @test isa(d, LittleDict{Int,Int})
        @test isa(d2, LittleDict{Int,Int})
        @test isa(d3, LittleDict{Int,Int})
        @test isa(d4, LittleDict{Int,Int})
    end

    @testset "from tuple/vector/pairs/tuple of pair 2" begin
        d = LittleDict(((1, 2), (3, "b")))
        d2 = LittleDict([(1, 2), (3, "b")])
        d3 = LittleDict(1 => 2, 3 => "b")
        d4 = LittleDict((1 => 2, 3 => "b"))

        @test d2[1] === 2
        @test d2[3] == "b"

        @test d == d2 == d3 == d4
        @test isa(d, LittleDict{Int,Any})
        @test isa(d2, LittleDict{Int,Any})
        @test isa(d3, LittleDict{Int,Any})
        @test isa(d4, LittleDict{Int,Any})
    end

    @testset "from tuple/vector/pairs/tuple of pair 3" begin
        d = LittleDict(((1, 2), ("a", 4)))
        d2 = LittleDict([(1, 2), ("a", 4)])
        d3 = LittleDict(1 => 2, "a" => 4)
        d4 = LittleDict((1 => 2, "a" => 4))

        @test d2[1] === 2
        @test d2["a"] === 4

        ## TODO: tuple of tuples doesn't work for mixed tuple types
        # @test d == d2 == d3 == d4
        @test d2 == d3 == d4
        # @test isa(d, LittleDict{Any,Int})
        @test isa(d2, LittleDict{Any,Int})
        @test isa(d3, LittleDict{Any,Int})
        @test isa(d4, LittleDict{Any,Int})
    end

    @testset "from tuple/vector/pairs/tuple of pair 4" begin
        d = LittleDict(((1, 2), ("a", "b")))
        d2 = LittleDict([(1, 2), ("a", "b")])
        d3 = LittleDict(1 => 2, "a" => "b")
        d4 = LittleDict((1 => 2, "a" => "b"))

        @test d[1] === 2
        @test d["a"] == "b"

        @test d == d2 == d3 == d4
        @test isa(d, LittleDict{Any,Any})
        @test isa(d2, LittleDict{Any,Any})
        @test isa(d3, LittleDict{Any,Any})
        @test isa(d4, LittleDict{Any,Any})
    end

    @testset "first" begin
        @test_throws ArgumentError first(LittleDict())
        @test first(LittleDict([(:f, 2)])) == Pair(:f,2)
    end


    @testset "iterate" begin
        d = LittleDict("a" => [1, 2])
        val1, state1 = iterate(d)
        @test val1 == ("a" => [1, 2])
        @test iterate(d, state1) === nothing
    end


    @testset "Failing to add a value but being able to add a key (cf: Issue #1821)" begin
        d = LittleDict{String, Vector{Int}}()
        d["a"] = [1, 2]
        @test_throws MethodError d["b"] = 1
        @test isa(repr(d), AbstractString)  # check that printable without error
    end

    @testset "Issue #2344" begin
        bestkey(d, key) = key
        bestkey(d::AbstractDict{K,V}, key) where {K<:AbstractString,V} = string(key)
        bar(x) = bestkey(x, :y)
        @test bar(LittleDict([(:x, [1,2,5])])) == :y
        @test bar(LittleDict([("x", [1,2,5])])) == "y"
    end

    @testset "isequal" begin
        @test  isequal(LittleDict(), LittleDict())
        @test  isequal(LittleDict([(1, 1)]), LittleDict([(1, 1)]))
        @test !isequal(LittleDict([(1, 1)]), LittleDict())
        @test !isequal(LittleDict([(1, 1)]), LittleDict([(1, 2)]))
        @test !isequal(LittleDict([(1, 1)]), LittleDict([(2, 1)]))

        @test isequal(LittleDict(), sizehint!(LittleDict(),96))

        # Here is what currently happens when dictionaries of different types
        # are compared. This is not necessarily desirable. These tests are
        # descriptive rather than proscriptive.
        @test !isequal(LittleDict([(1, 2)]), LittleDict([("dog", "bone")]))
        @test isequal(LittleDict{Int,Int}(), LittleDict{AbstractString,AbstractString}())
    end


    @testset "data_in" begin
        # Generate some data to populate dicts to be compared
        data_in = [ (rand(1:1000), randstring(2)) for _ in 1:1001 ]

        # Populate the first dict
        d1 = LittleDict{Int, String}()
        for (k,v) in data_in
            d1[k] = v
        end
        data_in = collect(d1)
        # shuffle the data
        for i in 1:length(data_in)
            j = rand(1:length(data_in))
            data_in[i], data_in[j] = data_in[j], data_in[i]
        end
        # Inserting data in different (shuffled) order should result in
        # equivalent dict.
        d2 = LittleDict{Int, AbstractString}()
        for (k,v) in data_in
            d2[k] = v
        end

        @test  isequal(d1, d2)
        d3 = copy(d2)
        d4 = copy(d2)
        # Removing an item gives different dict
        delete!(d1, data_in[rand(1:length(data_in))][1])
        @test !isequal(d1, d2)
        # Changing a value gives different dict
        d3[data_in[rand(1:length(data_in))][1]] = randstring(3)
        !isequal(d1, d3)
        # Adding a pair gives different dict
        d4[1001] = randstring(3)
        @test !isequal(d1, d4)
    end

    @testset "get!" begin
        # get! (get with default values assigned to the given location)
        f(x) = x^2
        d = LittleDict(8 => 19)

        @test get!(d, 8, 5) == 19
        @test get!(d, 19, 2) == 2

        @test get!(d, 42) do  # key not found, d is updated with f(2)
            f(2)
        end == 4

        @test get!(d, 42) do  # key found, d is not updated
            f(200)
        end == 4

        @test get(d, 13) do   # key not found, d is not updated
            f(4)
        end == 16

        @test get(d, 42) do   # key found, d is not updated
            error("this code is not reached")
        end == 4

        @test d == LittleDict(8=>19, 19=>2, 42=>4)
    end

    @testset "Issue #5886" begin
        d5886 = LittleDict()
        for k5886 in 1:11
            d5886[k5886] = 1
        end
        for k5886 in keys(d5886)
            # undefined ref if not fixed
            d5886[k5886] += 1
        end
    end

    @testset "isordered (Issue #216)1" begin
        @test OrderedCollections.isordered(LittleDict{Int, String})
        @test !OrderedCollections.isordered(Dict{Int, String})
    end

    @testset "Test merging" begin
        a = LittleDict("foo"  => 0.0, "bar" => 42.0)
        b = LittleDict("フー" => 17, "バー" => 4711)
        result = merge(a, b)
        @test isa(result, LittleDict{String,Float64})

        expected = LittleDict("foo"  => 0.0, "bar" => 42.0, "フー" => 17, "バー" => 4711)
        @test result == expected

        c = LittleDict("a" => 1, "b" => 2, "c" => 3)
        result = merge(a, b, c)
        @test isa(result, LittleDict{String,Float64})

        expected = LittleDict(
            "foo" => 0.0, "bar" => 42.0,
            "フー" => 17, "バー" => 4711,
            "a" => 1, "b" => 2, "c" => 3,
        )
        @test result == expected

        c = LittleDict("a" => 1, "b" => 2, "foo" => 3)
        result = merge(a, b, c)
        @test isa(result, LittleDict{String,Float64})

        expected = LittleDict(
            "foo" => 3, "bar" => 42.0,
            "フー" => 17, "バー" => 4711,
            "a" => 1, "b" => 2,
        )
        @test result == expected
    end

    @testset "Issue #9295" begin
        d = LittleDict()
        @test push!(d, 'a'=> 1) === d
        @test d['a'] == 1
        @test push!(d, 'b' => 2, 'c' => 3) === d
        @test d['b'] == 2
        @test d['c'] == 3
        @test push!(d, 'd' => 4, 'e' => 5, 'f' => 6) === d
        @test d['d'] == 4
        @test d['e'] == 5
        @test d['f'] == 6
        @test length(d) == 6
    end

    @testset "Serialization" begin
        s = IOBuffer()
        od = LittleDict{Char,Int64}()
        for c in 'a':'e'
            od[c] = c-'a'+1
        end
        serialize(s, od)
        seek(s, 0)
        dd = deserialize(s)
        @test isa(dd, OrderedCollections.LittleDict{Char,Int64})
        @test dd == od
        close(s)
    end

    @testset "Issue #148" begin
        d148 = LittleDict(
                    :gps => [],
                    :direction => 1:8,
                    :weather => 1:10
            )

        d148_2 = LittleDict(
            :time => 1:10,
            :features => LittleDict(
                :gps => 1:5,
                :direction => 1:8,
                :weather => 1:10
            )
        )
    end

    @testset "Issue #400" begin
        @test filter(p->first(p) > 1, LittleDict(1=>2, 3=>4)) isa LittleDict
    end

    @testset "Sorting" begin
        ks = [4, 8, 1, 7, 9, 3, 10, 2, 6, 5]
        d = LittleDict(i=>Char(123-i) for i in ks)

        sd = sort(d)
        @test collect(keys(d)) == ks    # verify d is not changed by sort()
        @test collect(keys(sd)) == 1:10
        @test collect(values(sd)) == collect('z':-1:'q')
        @test sort(sd) == sd

        @test !issorted(d; byvalue=true)
        sdv = sort(d; byvalue=true)
        @test issorted(sdv; byvalue=true)
        @test collect(keys(d)) == ks    # verify d is not changed by sort()
        @test collect(keys(sdv)) == 10:-1:1
        @test collect(values(sdv)) == collect('q':'z')

        sort!(d)
        @test collect(keys(d)) == 1:10
        @test collect(values(d)) == collect('z':-1:'q')
        @test sort(d) == d == sd

        sort!(d; byvalue=true)
        @test collect(keys(d)) == 10:-1:1
        @test collect(values(d)) == collect('q':'z')
        @test sort(d) == d == sd
    end

    @testset "Test that LittleDict merge with combiner returns type LittleDict" begin
        @test merge(+, LittleDict(:a=>1, :b=>2), LittleDict(:b=>7, :c=>4)) == LittleDict(:a=>1, :b=>9, :c=>4)
        @test merge(+, LittleDict(:a=>1, :b=>2), Dict(:b=>7, :c=>4)) isa LittleDict
    end

    @testset "Test that LittleDict mergewith returns type LittleDict" begin
        @test mergewith(+, LittleDict(:a=>1, :b=>2), LittleDict(:b=>7, :c=>4)) == LittleDict(:a=>1, :b=>9, :c=>4)
        @test mergewith(+, LittleDict(:a=>1, :b=>2), Dict(:b=>7, :c=>4)) isa LittleDict
    end

    @testset "issue #27" begin
        d = LittleDict{Symbol, Int}(:x=>1)
        d1 = LittleDict(:x=>1)
        d_wide = LittleDict{Symbol, Number}(:x=>1)
        @test d == d1 == d_wide
        @test d isa LittleDict{Symbol, Int}
        @test d1 isa LittleDict{Symbol, Int}
        @test d_wide isa LittleDict{Symbol, Number}

        @test_throws MethodError LittleDict{Char,Char}(:x => 1)
    end
end # @testset LittleDict


@testset "Frozen LittleDict" begin

    @testset "types" begin
        base_dict = LittleDict((10,20,30),("a", "b", "c"))
        @test base_dict isa LittleDict{Int, String, <:Tuple, <:Tuple}

        nonfrozen = LittleDict(10=>"a", 20=>"b", 30=>"c")
        @test nonfrozen isa LittleDict{Int, String, <:Vector, <:Vector}

        @test base_dict == nonfrozen

        frozen = freeze(nonfrozen)
        @test frozen isa LittleDict{Int, String, <:Tuple, <:Tuple}
        @test frozen == base_dict
        @test frozen === base_dict
    end

    @testset "get" begin
        fd = LittleDict((10,20,30),("a", "b", "c"))
        @test fd[10] == "a"
        @test fd[20] == "b"
        @test fd[30] == "c"
        @test_throws KeyError fd[-1]
    end

    @testset "set" begin
        fd = LittleDict((10,20,30),("a", "b", "c"))
        @test_throws MethodError fd[10] = "ab"
        @test_throws MethodError fd[20] = "bb"
        @test_throws MethodError fd[30] = "cc"
        @test_throws MethodError fd[-1] = "dd"
    end

    @testset "map!(f, values(LittleDict))" begin
        testdict = LittleDict(:a=>1, :b=>2)
        map!(v->v-1, values(testdict))
        @test testdict[:a] == 0
        @test testdict[:b] == 1
    end

    @testset "lazy reverse iteration" begin
        ks = collect('a':'z')
        vs = collect(0:25)
        ld = LittleDict(ks, vs)
        pass = true
        for (n,(k,v)) in enumerate(Iterators.reverse(ld))
            pass &= reverse(ks)[n] == k
            pass &= reverse(vs)[n] == v
        end
        @test pass
    end

end

# Sort for dicts
import Base: sort, sort!, issorted

function sort!(d::OrderedDict; byvalue::Bool=false, args...)
    if d.ndel > 0
        rehash!(d)
    end

    data = byvalue ? d.vals : d.keys

    # Filter out the kwargs supported by issorted (notably, :alg needs to be removed)
    issorted_kw = NamedTuple(k => v for (k, v) in args if k in (:lt, :by, :rev, :order))
    issorted(data; issorted_kw...) && return d

    p = sortperm(data; args...)
    d.keys = d.keys[p]
    d.vals = d.vals[p]
    rehash!(d)
    return d
end

# Compared to just sorting the underlying OrderedDict, this method calls sort!
# directly on the keys (no need to sort d.vals::Vector{Nothing}). This saves
# the allocation of the permutation vector in sortperm, and subsequent
# allocations of new d.keys and d.vals vectors.
function sort!(s::OrderedSet; kwargs...)
    d = s.dict
    d.ndel > 0 && rehash!(d)
    sort!(d.keys; kwargs...)
    rehash!(d)
    return s
end

function sort!(d::UnfrozenLittleDict; byvalue::Bool=false, args...)
    if byvalue
        p = sortperm(d.vals; args...)
    else
        p = sortperm(d.keys; args...)
    end
    permute!(d.keys, p)
    permute!(d.vals, p)
    return d
end

sort(d::Union{OrderedDict,OrderedSet}; args...) = sort!(copy(d); args...)

@deprecate sort(d::Dict; args...) sort!(OrderedDict(d); args...)

function sort(d::LittleDict; byvalue::Bool=false, args...)
    if byvalue
        p = sortperm(d.vals; args...)
    else
        p = sortperm(d.keys; args...)
    end
    return LittleDict(d.keys[p], d.vals[p])
end

function issorted(d::LittleDict; byvalue::Bool=false, args...)
    if byvalue
        return issorted(d.vals; args...)
    else
        return issorted(d.keys; args...)
    end
end

using OrderedCollections, Test

@testset "OrderedSet" begin

    @testset "Constructors" begin
        @test isa(OrderedSet{Int}(keys(OrderedDict{Int,Float64}(zeros(Int,16), Vector{Int}(), Vector{Float64}(), 0, 0, false))), OrderedSet{Int})
        @test isa(OrderedSet{Int}(keys(OrderedDict([(1,2.0)]))), OrderedSet{Int})
        @test isa(OrderedSet(), OrderedSet{Any})
        @test isa(OrderedSet([1,2,3]), OrderedSet{Int})
        @test isa(OrderedSet{Int}([3]), OrderedSet{Int})
        data_in = (1, "banana", ())
        s = OrderedSet(data_in)
        data_out = collect(s)
        @test isa(data_out, Vector{Any})
        @test tuple(data_out...) === data_in
        @test tuple(data_in...) === tuple(s...)
        @test length(data_out) == length(data_in)
    end

    @testset "hash" begin
        s1 = OrderedSet{String}(["bar", "foo"])
        s2 = OrderedSet{String}(["foo", "bar"])
        s3 = OrderedSet{String}(["baz"])
        @test hash(s1) != hash(s2)
        @test hash(s1) != hash(s3)
    end

    @testset "isequal" begin
        @test  isequal(OrderedSet(), OrderedSet())
        @test !isequal(OrderedSet(), OrderedSet([1]))
        @test  isequal(OrderedSet{Any}(Any[1,2]), OrderedSet{Int}([1,2]))
        @test !isequal(OrderedSet{Any}(Any[1,2]), OrderedSet{Int}([1,2,3]))

        @test  isequal(OrderedSet{Int}(), OrderedSet{AbstractString}())
        @test !isequal(OrderedSet{Int}(), OrderedSet{AbstractString}([""]))
        @test !isequal(OrderedSet{AbstractString}(), OrderedSet{Int}([0]))
        @test !isequal(OrderedSet{Int}([1]), OrderedSet{AbstractString}())
        @test  isequal(OrderedSet{Any}([1,2,3]), OrderedSet{Int}([1,2,3]))
        @test  isequal(OrderedSet{Int}([1,2,3]), OrderedSet{Any}([1,2,3]))
        @test !isequal(OrderedSet{Any}([1,2,3]), OrderedSet{Int}([1,2,3,4]))
        @test !isequal(OrderedSet{Int}([1,2,3]), OrderedSet{Any}([1,2,3,4]))
        @test !isequal(OrderedSet{Any}([1,2,3,4]), OrderedSet{Int}([1,2,3]))
        @test !isequal(OrderedSet{Int}([1,2,3,4]), OrderedSet{Any}([1,2,3]))
    end

    @testset "eltype, empty" begin
        s1 = empty(OrderedSet([1,"hello"]))
        @test isequal(s1, OrderedSet())
        @test eltype(s1) === Any
        s2 = empty(OrderedSet{Float32}([2.0f0,3.0f0,4.0f0]))
        @test isequal(s2, OrderedSet())
        @test eltype(s2) === Float32
    end

    @testset "show" begin
        @test endswith(sprint(show, OrderedSet()), "OrderedSet{Any}()")
        @test endswith(sprint(show, OrderedSet(['a'])), "OrderedSet{Char}(['a'])")
    end

    @testset "Core Functionality" begin
        s = OrderedSet(); push!(s,1); push!(s,2); push!(s,3)
        @test !isempty(s)
        @test in(1,s)
        @test in(2,s)
        @test length(s) == 3
        push!(s,1); push!(s,2); push!(s,3)
        @test length(s) == 3
        @test pop!(s,1) == 1
        @test !in(1,s)
        @test in(2,s)
        @test length(s) == 2
        @test_throws KeyError pop!(s,1)
        @test pop!(s,1,:foo) == :foo
        @test length(delete!(s,2)) == 1
        @test !in(1,s)
        @test !in(2,s)
        @test pop!(s) == 3
        @test length(s) == 0
        @test isempty(s)
    end

    @testset "copy" begin
        data_in = (1,2,9,8,4)
        s = OrderedSet(data_in)
        c = copy(s)
        @test isequal(s,c)
        v = pop!(s)
        @test !in(v,s)
        @test  in(v,c)
        push!(s,100)
        push!(c,200)
        @test !in(100,c)
        @test !in(200,s)
    end

    @testset "sizehint!, empty" begin
        s = OrderedSet([1])
        @test isequal(sizehint!(s, 10), OrderedSet([1]))
        @test isequal(empty!(s), OrderedSet())
        # TODO: rehash
    end

    @testset "iterate" begin
        for data_in in ((7,8,4,5),
                        ("hello", 23, 2.7, (), [], (1,8)))
            s = OrderedSet(data_in)

            s_new = OrderedSet()
            for el in s
                push!(s_new, el)
            end
            @test isequal(s, s_new)

            t = tuple(s...)

            @test t === data_in
            @test length(t) == length(s)
            for (e,f) in zip(t,s)
                @test e === f
            end
        end
    end

    @testset "union" begin
        @test isequal(union(OrderedSet([1])),OrderedSet([1]))
        s = ∪(OrderedSet([1,2]), OrderedSet([3,4]))
        @test isequal(s, OrderedSet([1,2,3,4]))
        s = union(OrderedSet([5,6,7,8]), OrderedSet([7,8,9]))
        @test isequal(s, OrderedSet([5,6,7,8,9]))
        s = OrderedSet([1,3,5,7])
        union!(s,(2,3,4,5))
        # TODO: order is not the same, so isequal should return false...
        @test isequal(s,OrderedSet([1,2,3,4,5,7]))
    end

    @testset "intersect" begin
        @test isequal(intersect(OrderedSet([1])),OrderedSet([1]))
        s = ∩(OrderedSet([1,2]), OrderedSet([3,4]))
        @test isequal(s, OrderedSet())
        s = intersect(OrderedSet([5,6,7,8]), OrderedSet([7,8,9]))
        @test isequal(s, OrderedSet([7,8]))
        @test isequal(intersect(OrderedSet([2,3,1]), OrderedSet([4,2,3]), OrderedSet([5,4,3,2])), OrderedSet([2,3]))
    end

    @testset "setdiff" begin
        @test isequal(setdiff(OrderedSet([1,2,3]), OrderedSet()),        OrderedSet([1,2,3]))
        @test isequal(setdiff(OrderedSet([1,2,3]), OrderedSet([1])),     OrderedSet([2,3]))
        @test isequal(setdiff(OrderedSet([1,2,3]), Set([1])),            OrderedSet([2,3]))
        @test isequal(setdiff(OrderedSet([1,2,3]), OrderedSet([1,2])),   OrderedSet([3]))
        @test isequal(setdiff(OrderedSet([1,2,3]), Set([1,2])),          OrderedSet([3]))
        @test isequal(setdiff(OrderedSet([1,2,3]), OrderedSet([1,2,3])), OrderedSet())
        @test isequal(setdiff(OrderedSet([1,2,3]), OrderedSet([4])),     OrderedSet([1,2,3]))
        @test isequal(setdiff(OrderedSet([1,2,3]), OrderedSet([4,1])),   OrderedSet([2,3]))
        s = OrderedSet([1,3,5,7])
        setdiff!(s,(3,5))
        @test isequal(s,OrderedSet([1,7]))
        s = OrderedSet([1,2,3,4])
        setdiff!(s, OrderedSet([2,4,5,6]))
        @test isequal(s,OrderedSet([1,3]))
    end

    @testset "ordering" begin
        @test OrderedSet() < OrderedSet([1])
        @test OrderedSet([1]) < OrderedSet([1,2])
        @test !(OrderedSet([3]) < OrderedSet([1,2]))
        @test !(OrderedSet([3]) > OrderedSet([1,2]))
        @test OrderedSet([1,2,3]) > OrderedSet([1,2])
        @test !(OrderedSet([3]) <= OrderedSet([1,2]))
        @test !(OrderedSet([3]) >= OrderedSet([1,2]))
        @test OrderedSet([1]) <= OrderedSet([1,2])
        @test OrderedSet([1,2]) <= OrderedSet([1,2])
        @test OrderedSet([1,2]) >= OrderedSet([1,2])
        @test OrderedSet([1,2,3]) >= OrderedSet([1,2])
        @test !(OrderedSet([1,2,3]) >= OrderedSet([1,2,4]))
        @test !(OrderedSet([1,2,3]) <= OrderedSet([1,2,4]))
    end

    @testset "issubset, symdiff" begin
        for (l,r) in ((OrderedSet([1,2]),     OrderedSet([3,4])),
                    (OrderedSet([5,6,7,8]), OrderedSet([7,8,9])),
                    (OrderedSet([1,2]),     OrderedSet([3,4])),
                    (OrderedSet([5,6,7,8]), OrderedSet([7,8,9])),
                    (OrderedSet([1,2,3]),   OrderedSet()),
                    (OrderedSet([1,2,3]),   OrderedSet([1])),
                    (OrderedSet([1,2,3]),   OrderedSet([1,2])),
                    (OrderedSet([1,2,3]),   OrderedSet([1,2,3])),
                    (OrderedSet([1,2,3]),   OrderedSet([4])),
                    (OrderedSet([1,2,3]),   OrderedSet([4,1])))
            @test issubset(intersect(l,r), l)
            @test issubset(intersect(l,r), r)
            @test issubset(l, union(l,r))
            @test issubset(r, union(l,r))
            @test isequal(union(intersect(l,r),symdiff(l,r)), union(l,r))
        end
        @test ⊆(OrderedSet([1]), OrderedSet([1,2]))

        @test ⊊(OrderedSet([1]), OrderedSet([1,2]))
        @test !⊊(OrderedSet([1]), OrderedSet([1]))
        @test ⊈(OrderedSet([1]), OrderedSet([2]))

        @test symdiff(OrderedSet([1,2,3,4]), OrderedSet([2,4,5,6])) == OrderedSet([1,3,5,6])

        @test isequal(symdiff(OrderedSet([1,2,3,4]), OrderedSet([2,4,5,6])), OrderedSet([1,3,5,6]))

    end

    @testset "filter" begin
        s = OrderedSet([1,2,3,4])
        @test isequal(filter(isodd,s), OrderedSet([1,3]))
        filter!(isodd, s)
        @test isequal(s, OrderedSet([1,3]))
    end

    @testset "first" begin
        @test_throws ArgumentError first(OrderedSet())
        @test first(OrderedSet([2])) == 2
    end

    @testset "empty set" begin
        d = OrderedSet{Char}()
        @test length(d) == 0
        @test isempty(d)
        @test !('c' in d)
        push!(d, 'c')
        @test !isempty(d)
        empty!(d)
        @test isempty(d)
    end

    @testset "access, modification" begin
        d = OrderedSet{Char}()

        for c in 'a':'z'
            push!(d, c)
        end

        for c in 'a':'z'
            @test c in d
        end

        @test collect(d) == collect('a':'z')
    end

    @testset "sort(!)" begin
        x = [-4, 1, -5, 10, 7]
        ox = OrderedSet(x)
        @test !issorted(ox)
        sox = sort(ox)
        @test issorted(sox)
        sox = sort(ox; rev=true)
        @test !issorted(sox)
        @test issorted(sox; rev=true)
        ox = OrderedSet(x)
        @test ox === sort!(ox)
        @test issorted(ox)
        ox = OrderedSet(x)
        @test ox === sort!(ox; rev=true)
        @test !issorted(ox)
        @test issorted(ox; rev=true)
    end

    @testset "lazy reverse iteration" begin
        ks = collect('a':'z')
        os  = OrderedSet(ks)
        pass = true
        for (n,k) in enumerate(Iterators.reverse(os))
            pass &= reverse(ks)[n] == k
        end
        @test pass
    end
end # @testset OrderedSet

# support functions

# _tablesz and hashindex are defined in Base, but are not exported,
# so they are redefined here.
_tablesz(x::Integer) = x < 16 ? 16 : one(x)<<((sizeof(x)<<3)-leading_zeros(x-1))
hashindex(key, sz) = (reinterpret(Int,(hash(key))) & (sz-1)) + 1

const orderedset_seed = UInt === UInt64 ? 0x2114638a942a91a5 : 0xd86bdbf1

struct NotFoundSentinel end  # Struct to mark not not found

using Base: isbitsunion

# These can be changed, to trade off better performance for space
const global maxallowedprobe = isdefined(Base, :maxallowedprobe) ? Base.maxallowedprobe : 16
const global maxprobeshift   = isdefined(Base, :maxprobeshift) ? Base.maxprobeshift : 6

"""
    OrderedDict

`OrderedDict`s are simply dictionaries whose entries have a particular order. The order
refers to insertion order, which allows deterministic iteration over the dictionary.
"""
mutable struct OrderedDict{K,V} <: AbstractDict{K,V}
    slots::Vector{Int32}
    keys::Vector{K}
    vals::Vector{V}
    ndel::Int
    maxprobe::Int
    dirty::Bool
end

function OrderedDict{K,V}() where {K,V}
    OrderedDict{K,V}(zeros(Int32,16), Vector{K}(), Vector{V}(), 0, 0, false)
end

function OrderedDict{K,V}(kv) where {K,V}
    h = OrderedDict{K,V}()
    for (k,v) in kv
        h[k] = v
    end
    return h
end

OrderedDict{K,V}(p::Pair) where {K,V} = setindex!(OrderedDict{K,V}(), p.second, p.first)

function OrderedDict{K,V}(ps::Pair...) where {K,V}
    h = OrderedDict{K,V}()
    sizehint!(h, length(ps))
    for p in ps
        h[p.first] = p.second
    end
    return h
end

function OrderedDict{K,V}(d::OrderedDict{K,V}) where {K,V}
    if d.ndel > 0
        rehash!(d)
    end
    @assert d.ndel == 0
    OrderedDict{K,V}(copy(d.slots), copy(d.keys), copy(d.vals), 0, d.maxprobe, false)
end

OrderedDict() = OrderedDict{Any,Any}()
OrderedDict(kv::Tuple{}) = OrderedDict()
copy(d::OrderedDict) = OrderedDict(d)

# TODO: this can probably be simplified using `eltype` as a THT (Tim Holy trait)
# OrderedDict{K,V}(kv::Tuple{Vararg{Tuple{K,V}}})     = OrderedDict{K,V}(kv)
# OrderedDict{K  }(kv::Tuple{Vararg{Tuple{K,Any}}})   = OrderedDict{K,Any}(kv)
# OrderedDict{V  }(kv::Tuple{Vararg{Tuple{Any,V}}})   = OrderedDict{Any,V}(kv)
OrderedDict(kv::Tuple{Vararg{Pair{K,V}}}) where {K,V}  = OrderedDict{K,V}(kv)

OrderedDict(kv::AbstractArray{Tuple{K,V}}) where {K,V} = OrderedDict{K,V}(kv)
OrderedDict(kv::AbstractArray{Pair{K,V}}) where {K,V}  = OrderedDict{K,V}(kv)
OrderedDict(kv::AbstractDict{K,V}) where {K,V}         = OrderedDict{K,V}(kv)

OrderedDict(ps::Pair{K,V}...) where {K,V} = OrderedDict{K,V}(ps)
OrderedDict(ps::Pair...)                  = OrderedDict(ps)

@static if VERSION >= v"1.11"
    # see JuliaLang/julia#53151
    OrderedDict(kv) = dict_with_eltype((K, V) -> OrderedDict{K, V}, kv, eltype(kv))
else
    function OrderedDict(kv)
        try
            dict_with_eltype((K, V) -> OrderedDict{K, V}, kv, eltype(kv))
        catch e
            if isempty(methods(iterate, (typeof(kv),))) ||
                !all(x->isa(x, Union{Tuple,Pair}), kv)
                throw(ArgumentError("OrderedDict(kv): kv needs to be an iterator of tuples or pairs"))
            else
                rethrow(e)
            end
        end
    end
end

empty(d::OrderedDict{K,V}) where {K,V} = OrderedDict{K,V}()
empty(d::OrderedDict, ::Type{K}, ::Type{V}) where {K, V} = OrderedDict{K, V}()

length(d::OrderedDict) = length(d.keys) - d.ndel
isempty(d::OrderedDict) = (length(d) == 0)

"""
    isordered(::Type)

Property of associative containers, that is `true` if the container type has a
defined order (such as `OrderedDict` and `SortedDict`), and `false` otherwise.
"""
isordered(::Type{T}) where {T<:AbstractDict} = false
isordered(::Type{T}) where {T<:OrderedDict} = true

# conversion between OrderedDict types
function convert(::Type{OrderedDict{K,V}}, d::AbstractDict) where {K,V}
    d isa OrderedDict{K, V} && return d
    if !isordered(typeof(d))
        Base.depwarn("Conversion to OrderedDict is deprecated for unordered associative containers (in this case, $(typeof(d))). Use an ordered or sorted associative type, such as SortedDict and OrderedDict.", :convert)
    end
    h = OrderedDict{K,V}()
    for (k,v) in d
        ck = convert(K,k)
        if !haskey(h,ck)
            h[ck] = convert(V,v)
        else
            error("key collision during dictionary conversion")
        end
    end
    return h
end

isslotempty(slot_value::Integer) = slot_value == 0
isslotfilled(slot_value::Integer) = slot_value > 0
isslotmissing(slot_value::Integer) = slot_value < 0

function rehash!(h::OrderedDict{K,V}, newsz::Integer = length(h.slots)) where {K,V}
    olds = h.slots
    keys = h.keys
    vals = h.vals
    sz = length(olds)
    newsz = _tablesz(newsz)
    h.dirty = true
    count0 = length(h)
    if count0 == 0
        resize!(h.slots, newsz)
        fill!(h.slots, 0)
        resize!(h.keys, 0)
        resize!(h.vals, 0)
        h.ndel = 0
        return h
    end

    slots = zeros(Int32, newsz)
    maxprobe = 0

    if h.ndel > 0
        ndel0 = h.ndel
        ptrs = !isbitstype(K) && !isbitsunion(K)
        to = 1
        # TODO: to get the best performance we need to avoid reallocating these.
        # This algorithm actually works in place, unless the dict is modified
        # due to GC during this process.
        newkeys = similar(keys, count0)
        newvals = similar(vals, count0)
        @inbounds for from = 1:length(keys)
            if !ptrs || isassigned(keys, from)
                k = keys[from]
                hashk = hash(k)%Int
                isdeleted = false
                if !ptrs
                    iter = 0
                    index = (hashk & (sz-1)) + 1
                    while iter <= h.maxprobe
                        si = olds[index]
                        si == from && break
                        # if we find si == 0, then the key was deleted and it's slot was reused/overwritten
                        (si == -from || si == 0) && (isdeleted = true; break)
                        index = (index & (sz-1)) + 1
                        iter += 1
                    end
                    iter > h.maxprobe && (isdeleted = true)  # Another case where the slot was reused/overwritten
                end
                if !isdeleted
                    index0 = index = (hashk & (newsz-1)) + 1
                    while slots[index] != 0
                        index = (index & (newsz-1)) + 1
                    end
                    probe = (index - index0) & (newsz-1)
                    probe > maxprobe && (maxprobe = probe)
                    slots[index] = to
                    newkeys[to] = k
                    newvals[to] = vals[from]
                    to += 1
                end
                if h.ndel != ndel0
                    # if items are removed by finalizers, retry
                    return rehash!(h, newsz)
                end
            end
        end
        h.keys = newkeys
        h.vals = newvals
        h.ndel = 0
    else
        @inbounds for i = 1:count0
            k = keys[i]
            index0 = index = hashindex(k, newsz)
            while slots[index] != 0
                index = (index & (newsz-1)) + 1
            end
            probe = (index - index0) & (newsz-1)
            probe > maxprobe && (maxprobe = probe)
            slots[index] = i
            if h.ndel > 0
                # if items are removed by finalizers, retry
                return rehash!(h, newsz)
            end
        end
    end

    h.slots = slots
    h.maxprobe = maxprobe
    return h
end

function sizehint!(d::OrderedDict, newsz::Integer)
    slotsz = (newsz*3)>>1
    oldsz = length(d.slots)
    if slotsz <= oldsz
        # todo: shrink
        # be careful: rehash!() assumes everything fits. it was only designed
        # for growing.
        return d
    end
    # grow at least 25%
    slotsz = max(slotsz, (oldsz*5)>>2)
    rehash!(d, slotsz)
end

function empty!(h::OrderedDict{K,V}) where {K,V}
    fill!(h.slots, 0)
    empty!(h.keys)
    empty!(h.vals)
    h.ndel = 0
    h.dirty = true
    return h
end

# get the index where a key is stored, or -1 if not present
function ht_keyindex(h::OrderedDict{K,V}, key, direct) where {K,V}
    slots = h.slots
    sz = length(slots)
    iter = 0
    maxprobe = h.maxprobe
    index = hashindex(key, sz)
    keys = h.keys

    @inbounds while true
        si = slots[index]
        isslotempty(si) && break
        if isslotfilled(si) && isequal(key, keys[si])
            return ifelse(direct, oftype(index, si), index)
        end

        index = (index & (sz-1)) + 1
        iter += 1
        iter > maxprobe && break
    end

    return -1
end

# get the index where a key is stored, or -pos if not present
# and the key would be inserted at pos
# This version is for use by setindex! and get!
function ht_keyindex2(h::OrderedDict{K,V}, key) where {K,V}
    slots = h.slots
    sz = length(slots)
    iter = 0
    maxprobe = h.maxprobe
    index = hashindex(key, sz)
    keys = h.keys
    avail = 0

    @inbounds while true
        si = slots[index]
        if isslotempty(si)
            avail < 0 && return avail
            return -index
        end

        if isslotmissing(si)
            avail == 0 && (avail = -index)
        elseif key === keys[si] || isequal(key, keys[si])
            return oftype(index, si)
        end

        index = (index & (sz-1)) + 1
        iter += 1
        iter > maxprobe && break
    end

    avail < 0 && return avail

    # If key is not present, may need to keep searching to find slot
    maxallowed = max(maxallowedprobe, sz>>maxprobeshift)
    @inbounds while iter < maxallowed
        if !isslotfilled(slots[index])
            h.maxprobe = iter
            return -index
        end
        index = (index & (sz-1)) + 1
        iter += 1
    end

    rehash!(h, length(h) > 64000 ? sz*2 : sz*4)

    return ht_keyindex2(h, key)
end

function _setindex!(h::OrderedDict, v, key, index)
    hk, hv = h.keys, h.vals
    push!(hk, key)
    push!(hv, v)
    nk = length(hk)
    @inbounds h.slots[index] = nk
    h.dirty = true

    sz = length(h.slots)
    cnt = nk - h.ndel
    # Rehash now if necessary
    if h.ndel >= ((3*nk)>>2) > 4 || cnt*3 > sz*2
        # > 3/4 deleted or > 2/3 full
        rehash!(h, cnt > 64000 ? cnt*2 : cnt*4)
    end
end

function setindex!(h::OrderedDict{K,V}, v0, key0) where {K,V}
    key = convert(K, key0)
    if !isequal(key, key0)
        throw(ArgumentError("$key0 is not a valid key for type $K"))
    end
    v = convert(V, v0)

    index = ht_keyindex2(h, key)

    if index > 0
        @inbounds h.keys[index] = key
        @inbounds h.vals[index] = v
    else
        _setindex!(h, v, key, -index)
    end

    return h
end

function get!(h::OrderedDict{K,V}, key0, default) where {K,V}
    key = convert(K, key0)
    if !isequal(key, key0)
        throw(ArgumentError("$key0 is not a valid key for type $K"))
    end

    index = ht_keyindex2(h, key)

    index > 0 && return h.vals[index]

    v = convert(V,  default)
    _setindex!(h, v, key, -index)
    return v
end

function get!(default::Base.Callable, h::OrderedDict{K,V}, key0) where {K,V}
    key = convert(K, key0)
    if !isequal(key, key0)
        throw(ArgumentError("$key0 is not a valid key for type $K"))
    end

    index = ht_keyindex2(h, key)

    index > 0 && return h.vals[index]

    h.dirty = false
    v = convert(V,  default())
    if h.dirty  # calling default could have dirtied h
        index = ht_keyindex2(h, key)
    end
    if index > 0
        h.keys[index] = key
        h.vals[index] = v
    else
        _setindex!(h, v, key, -index)
    end
    return v
end

function getindex(h::OrderedDict{K,V}, key) where {K,V}
    index = ht_keyindex(h, key, true)
    return (index<0) ? throw(KeyError(key)) : h.vals[index]::V
end

function get(h::OrderedDict{K,V}, key, default) where {K,V}
    index = ht_keyindex(h, key, true)
    return (index<0) ? default : h.vals[index]::V
end

function get(default::Base.Callable, h::OrderedDict{K,V}, key) where {K,V}
    index = ht_keyindex(h, key, true)
    return (index<0) ? default() : h.vals[index]::V
end

haskey(h::OrderedDict, key) = (ht_keyindex(h, key, true) >= 0)
in(key, v::Base.KeySet{K,T}) where {K,T<:OrderedDict{K}} = (ht_keyindex(v.dict, key, true) >= 0)

function getkey(h::OrderedDict{K,V}, key, default) where {K,V}
    index = ht_keyindex(h, key, true)
    return (index<0) ? default : h.keys[index]::K
end

function _pop!(h::OrderedDict, index)
    @inbounds val = h.vals[h.slots[index]]
    _delete!(h, index)
    return val
end

function pop!(h::OrderedDict)
    h.ndel > 0 && rehash!(h)
    key = h.keys[end]
    index = ht_keyindex(h, key, false)
    return key => _pop!(h, index)
end

function popfirst!(h::OrderedDict)
    h.ndel > 0 && rehash!(h)
    key = h.keys[1]
    index = ht_keyindex(h, key, false)
    key => _pop!(h, index)
end

function pop!(h::OrderedDict, key)
    index = ht_keyindex(h, key, false)
    index > 0 ? _pop!(h, index) : throw(KeyError(key))
end

function pop!(h::OrderedDict, key, default)
    index = ht_keyindex(h, key, false)
    index > 0 ? _pop!(h, index) : default
end

function _delete!(h::OrderedDict, index)
    @inbounds ki = h.slots[index]
    @inbounds h.slots[index] = -ki
    @inbounds Base._unsetindex!(h.keys, Int(ki))
    @inbounds Base._unsetindex!(h.vals, Int(ki))
    h.ndel += 1
    h.dirty = true
    return h
end

function delete!(h::OrderedDict, key)
    index = ht_keyindex(h, key, false)
    if index > 0; _delete!(h, index); end
    return h
end

function iterate(t::OrderedDict{K,V}) where {K,V}
    t.ndel > 0 && rehash!(t)
    length(t.keys) < 1 && return nothing
    @inbounds return (Pair{K,V}(t.keys[1], t.vals[1]), 2)
end
function iterate(t::OrderedDict{K,V}, i) where {K,V}
    length(t.keys) < i && return nothing
    @inbounds return (Pair{K,V}(t.keys[i], t.vals[i]), i+1)
end

# lazy reverse iteration
function iterate(rt::Iterators.Reverse{<:OrderedDict{K,V}}) where {K,V}
    t = rt.itr
    t.ndel > 0 && rehash!(t)
    n = length(t.keys)
    n < 1 && return nothing
    @inbounds return (Pair{K,V}(t.keys[n], t.vals[n]), n - 1)
end
function iterate(rt::Iterators.Reverse{<:OrderedDict{K,V}}, i) where {K,V}
    t = rt.itr
    i < 1 && return nothing
    @inbounds return (Pair{K,V}(t.keys[i], t.vals[i]), i - 1)
end


function _merge_kvtypes(d, others...)
    K, V = keytype(d), valtype(d)
    for other in others
        K = promote_type(K, keytype(other))
        V = promote_type(V, valtype(other))
    end
    return (K,V)
end

function merge(d::OrderedDict, others::AbstractDict...)
    K,V = _merge_kvtypes(d, others...)
    merge!(OrderedDict{K,V}(), d, others...)
end

function mergewith(combine, d::OrderedDict, others::AbstractDict...)
    K,V = _merge_kvtypes(d, others...)
    mergewith!(combine, OrderedDict{K,V}(), d, others...)
end

merge(combine::Function, d::OrderedDict, others::AbstractDict...) = mergewith(combine, d, others...)

function Base.map!(f, iter::Base.ValueIterator{<:OrderedDict})
    dict = iter.dict
    vals = dict.vals
    elements = length(vals) - dict.ndel
    elements == 0 && return iter
    for i in dict.slots
        if i > 0
            @inbounds vals[i] = f(vals[i])
            elements -= 1
            elements == 0 && break
        end
    end
    return iter
end

last(h::OrderedDict) = h.keys[end] => h.vals[end]

using OrderedCollections, Test

@testset "LittleSet" begin

    @testset "Constructors" begin
        @test isa(LittleSet{Int}(keys(LittleDict{Int,Float64}(Vector{Int}(), Vector{Float64}()))), LittleSet{Int})
        @test isa(LittleSet{Int}(keys(LittleDict([(1,2.0)]))), LittleSet{Int})
        @test isa(LittleSet(), LittleSet{Any})
        @test isa(LittleSet([1,2,3]), LittleSet{Int})
        @test isa(LittleSet{Int}([3]), LittleSet{Int})
        data_in = (1, "banana", ())
        s = LittleSet(data_in)
        data_out = collect(s)
        @test isa(data_out, Array{Any,1})
        @test tuple(data_out...) === data_in
        @test tuple(data_in...) === tuple(s...)
        @test length(data_out) == length(data_in)
    end

    @testset "hash" begin
        s1 = LittleSet{String}(["bar", "foo"])
        s2 = LittleSet{String}(["foo", "bar"])
        s3 = LittleSet{String}(["baz"])
        @test hash(s1) != hash(s2)
        @test hash(s1) != hash(s3)
    end

    @testset "isequal" begin
        @test  isequal(LittleSet(), LittleSet())
        @test !isequal(LittleSet(), LittleSet([1]))
        @test  isequal(LittleSet{Any}(Any[1,2]), LittleSet{Int}([1,2]))
        @test !isequal(LittleSet{Any}(Any[1,2]), LittleSet{Int}([1,2,3]))

        @test  isequal(LittleSet{Int}(), LittleSet{AbstractString}())
        @test !isequal(LittleSet{Int}(), LittleSet{AbstractString}([""]))
        @test !isequal(LittleSet{AbstractString}(), LittleSet{Int}([0]))
        @test !isequal(LittleSet{Int}([1]), LittleSet{AbstractString}())
        @test  isequal(LittleSet{Any}([1,2,3]), LittleSet{Int}([1,2,3]))
        @test  isequal(LittleSet{Int}([1,2,3]), LittleSet{Any}([1,2,3]))
        @test !isequal(LittleSet{Any}([1,2,3]), LittleSet{Int}([1,2,3,4]))
        @test !isequal(LittleSet{Int}([1,2,3]), LittleSet{Any}([1,2,3,4]))
        @test !isequal(LittleSet{Any}([1,2,3,4]), LittleSet{Int}([1,2,3]))
        @test !isequal(LittleSet{Int}([1,2,3,4]), LittleSet{Any}([1,2,3]))
    end

    @testset "eltype, empty" begin
        s1 = empty(LittleSet([1,"hello"]))
        @test isequal(s1, LittleSet())
        @test eltype(s1) === Any
        s2 = empty(LittleSet{Float32}([2.0f0,3.0f0,4.0f0]))
        @test isequal(s2, LittleSet())
        @test eltype(s2) === Float32
    end

    @testset "Core Functionality" begin
        s = LittleSet(); push!(s,1); push!(s,2); push!(s,3)
        @test !isempty(s)
        @test in(1,s)
        @test in(2,s)
        @test length(s) == 3
        push!(s,1); push!(s,2); push!(s,3)
        @test length(s) == 3
        @test pop!(s,1) == 1
        @test !in(1,s)
        @test in(2,s)
        @test length(s) == 2
        @test_throws KeyError pop!(s,1)
        @test pop!(s,1,:foo) == :foo
        @test length(delete!(s,2)) == 1
        @test !in(1,s)
        @test !in(2,s)
        @test pop!(s) == 3
        @test length(s) == 0
        @test isempty(s)
    end

    @testset "copy" begin
        data_in = [1,2,9,8,4]
        s = LittleSet(data_in)
        c = copy(s)
        @test isequal(s,c)
        v = pop!(s)
        @test !in(v,s)
        @test  in(v,c)
        push!(s,100)
        push!(c,200)
        @test !in(100,c)
        @test !in(200,s)
    end

    @testset "sizehint!, empty" begin
        s = LittleSet([1])
        @test isequal(sizehint!(s, 10), LittleSet([1]))
        @test isequal(empty!(s), LittleSet())
        # TODO: rehash
    end

    @testset "iterate" begin
        for data_in in ((7,8,4,5),
                        ("hello", 23, 2.7, (), [], (1,8)))
            s = LittleSet(data_in)

            s_new = LittleSet()
            for el in s
                push!(s_new, el)
            end
            @test isequal(s, s_new)

            t = tuple(s...)

            @test t === data_in
            @test length(t) == length(s)
            for (e,f) in zip(t,s)
                @test e === f
            end
        end
    end

    @testset "union" begin
        @test isequal(union(LittleSet([1])),LittleSet([1]))

        s = ∪(LittleSet([1,2]), LittleSet([3,4]))
        @test isequal(s, LittleSet([1,2,3,4]))

        s = ∪(LittleSet((1, 2)), LittleSet((3,4)))
        @test isequal(s, LittleSet((1,2,3,4)))

        s1 = LittleSet{Int, Tuple{Vararg{Int}}}((1, 2))
        s2 = LittleSet{Int, Tuple{Vararg{Int}}}((3,4))
        s = @inferred(∪(s1, s2))
        @test isequal(s, LittleSet((1,2,3,4)))

        s = union(LittleSet([5,6,7,8]), LittleSet([7,8,9]))
        @test isequal(s, LittleSet([5,6,7,8,9]))
        s = LittleSet([1,3,5,7])
        union!(s,(2,3,4,5))
        # TODO: order is not the same, so isequal should return false...
        @test isequal(s, LittleSet([1,2,3,4,5,7]))
    end

    @testset "first" begin
        @test_throws ArgumentError first(LittleSet())
        @test first(LittleSet([2])) == 2

        s = LittleSet([1,2,3])
        @test length(first(s, 2)) == 2
        @test length(first(s, 10)) == 3

        s = LittleSet((1,2,3))
        @test length(first(s, 2)) == 2
        @test length(first(s, 10)) == 3

        s = LittleSet{Int, Tuple{Vararg{Int}}}((1,2,3))
        @test length(@inferred(first(s, 2))) == 2
    end

    @testset "last" begin
        s = LittleSet([1,2,3])
        @test length(last(s, 2)) == 2
        @test length(last(s, 10)) == 3

        s = LittleSet((1,2,3))
        @test length(last(s, 2)) == 2
        @test length(last(s, 10)) == 3

        s = LittleSet{Int, Tuple{Vararg{Int}}}((1,2,3))
        @test length(@inferred(last(s, 2))) == 2
    end

    @testset "intersect" begin
        @test isequal(intersect(LittleSet([1])),LittleSet([1]))
        s = ∩(LittleSet([1,2]), LittleSet([3,4]))
        @test isequal(s, LittleSet())
        s = intersect(LittleSet([5,6,7,8]), LittleSet([7,8,9]))
        @test isequal(s, LittleSet([7,8]))
        @test isequal(intersect(LittleSet([2,3,1]), LittleSet([4,2,3]), LittleSet([5,4,3,2])), LittleSet([2,3]))
    end

    @testset "setdiff" begin
        @test isequal(setdiff(LittleSet([1,2,3]), LittleSet()),        LittleSet([1,2,3]))
        @test isequal(setdiff(LittleSet([1,2,3]), LittleSet([1])),     LittleSet([2,3]))
        @test isequal(setdiff(LittleSet([1,2,3]), Set([1])),            LittleSet([2,3]))
        @test isequal(setdiff(LittleSet([1,2,3]), LittleSet([1,2])),   LittleSet([3]))
        @test isequal(setdiff(LittleSet([1,2,3]), Set([1,2])),          LittleSet([3]))
        @test isequal(setdiff(LittleSet([1,2,3]), LittleSet([1,2,3])), LittleSet())
        @test isequal(setdiff(LittleSet([1,2,3]), LittleSet([4])),     LittleSet([1,2,3]))
        @test isequal(setdiff(LittleSet([1,2,3]), LittleSet([4,1])),   LittleSet([2,3]))
        s = LittleSet([1,3,5,7])
        setdiff!(s,(3,5))
        @test isequal(s,LittleSet([1,7]))
        s = LittleSet([1,2,3,4])
        setdiff!(s, LittleSet([2,4,5,6]))
        @test isequal(s,LittleSet([1,3]))
    end

    @testset "ordering" begin
        @test LittleSet() < LittleSet([1])
        @test LittleSet([1]) < LittleSet([1,2])
        @test !(LittleSet([3]) < LittleSet([1,2]))
        @test !(LittleSet([3]) > LittleSet([1,2]))
        @test LittleSet([1,2,3]) > LittleSet([1,2])
        @test !(LittleSet([3]) <= LittleSet([1,2]))
        @test !(LittleSet([3]) >= LittleSet([1,2]))
        @test LittleSet([1]) <= LittleSet([1,2])
        @test LittleSet([1,2]) <= LittleSet([1,2])
        @test LittleSet([1,2]) >= LittleSet([1,2])
        @test LittleSet([1,2,3]) >= LittleSet([1,2])
        @test !(LittleSet([1,2,3]) >= LittleSet([1,2,4]))
        @test !(LittleSet([1,2,3]) <= LittleSet([1,2,4]))
    end

    @testset "issubset, symdiff" begin
        for (l,r) in ((LittleSet([1,2]),     LittleSet([3,4])),
                    (LittleSet([5,6,7,8]), LittleSet([7,8,9])),
                    (LittleSet([1,2]),     LittleSet([3,4])),
                    (LittleSet([5,6,7,8]), LittleSet([7,8,9])),
                    (LittleSet([1,2,3]),   LittleSet()),
                    (LittleSet([1,2,3]),   LittleSet([1])),
                    (LittleSet([1,2,3]),   LittleSet([1,2])),
                    (LittleSet([1,2,3]),   LittleSet([1,2,3])),
                    (LittleSet([1,2,3]),   LittleSet([4])),
                    (LittleSet([1,2,3]),   LittleSet([4,1])))
            @test issubset(intersect(l,r), l)
            @test issubset(intersect(l,r), r)
            @test issubset(l, union(l,r))
            @test issubset(r, union(l,r))
            @test isequal(union(intersect(l,r),symdiff(l,r)), union(l,r))
        end
        @test ⊆(LittleSet([1]), LittleSet([1,2]))

        @test ⊊(LittleSet([1]), LittleSet([1,2]))
        @test !⊊(LittleSet([1]), LittleSet([1]))
        @test ⊈(LittleSet([1]), LittleSet([2]))

        @test symdiff(LittleSet([1,2,3,4]), LittleSet([2,4,5,6])) == LittleSet([1,3,5,6])

        @test isequal(symdiff(LittleSet([1,2,3,4]), LittleSet([2,4,5,6])), LittleSet([1,3,5,6]))

    end

    @testset "filter" begin
        s = LittleSet([1,2,3,4])
        @test isequal(filter(isodd,s), LittleSet([1,3]))
        filter!(isodd, s)
        @test isequal(s, LittleSet([1,3]))
        s = LittleSet((1,2,3,4))
        @test isa(filter(isodd, s), OrderedCollections.FrozenLittleSet)
    end

    @testset "replace" begin
        s = LittleSet([1,2,3,4])
        @test isequal(replace(s, 1 => 0, 2 => 5), LittleSet([0, 5, 3, 4]))
        s = LittleSet{Int, Tuple{Vararg{Int}}}((1,2,3,4))
        @test isequal(replace(s, 1 => 0, 2 => 5), LittleSet((0, 5, 3, 4)))
    end

    @testset "empty set" begin
        d = LittleSet{Char}()
        @test length(d) == 0
        @test isempty(d)
        @test !('c' in d)
        push!(d, 'c')
        @test !isempty(d)
        empty!(d)
        @test isempty(d)
    end

    @testset "access, modification" begin
        d = LittleSet{Char}()

        for c in 'a':'z'
            push!(d, c)
        end

        for c in 'a':'z'
            @test c in d
        end

        @test collect(d) == collect('a':'z')
    end

    @testset "sort(!)" begin
        x = [-4, 1, -5, 10, 7]
        ox = LittleSet(x)
        @test !issorted(ox)
        sox = sort(ox)
        @test issorted(sox)
        sox = sort(ox; rev=true)
        @test !issorted(sox)
        @test issorted(sox; rev=true)
        ox = LittleSet(x)
        @test ox === sort!(ox)
        @test issorted(ox)
        ox = LittleSet(x)
        @test ox === sort!(ox; rev=true)
        @test !issorted(ox)
        @test issorted(ox; rev=true)
    end

end # @testset LittleSet

"""
    OrderedSet

`OrderedSet`s are simply sets whose entries have a particular order. The order
refers to insertion order, which allows deterministic iteration over the set.

Note: To create an OrderedSet of a particular type, you must specify the type, such as,

```julia
os = OrderedSet{Int}(3)
push!(os, [1,2]...)
```
"""
struct OrderedSet{T}  <: AbstractSet{T}
    dict::OrderedDict{T,Nothing}

    OrderedSet{T}() where {T} = new{T}(OrderedDict{T,Nothing}())
    OrderedSet{T}(xs) where {T} = union!(OrderedSet{T}(), xs)
    function OrderedSet{T}(s::Base.KeySet{T, <:OrderedDict{T}}) where {T}
        d = s.dict
        slots = copy(d.slots)
        keys = copy(d.keys)
        vals = similar(d.vals, Nothing)
        new{T}(OrderedDict{T,Nothing}(slots, keys, vals, d.ndel, d.maxprobe, d.dirty))
    end
end

OrderedSet() = OrderedSet{Any}()
OrderedSet(xs) = OrderedSet{eltype(xs)}(xs)

show(io::IO, s::OrderedSet) = (show(io, typeof(s)); print(io, "("); !isempty(s) && Base.show_vector(io, s,'[',']'); print(io, ")"))

isempty(s::OrderedSet) = isempty(s.dict)
length(s::OrderedSet)  = length(s.dict)

sizehint!(s::OrderedSet, sz::Integer) = (sizehint!(s.dict, sz); s)

in(x, s::OrderedSet) = haskey(s.dict, x)

push!(s::OrderedSet, x) = (s.dict[x] = nothing; s)
pop!(s::OrderedSet, x) = (pop!(s.dict, x); x)
pop!(s::OrderedSet, x, deflt) = pop!(s.dict, x, deflt) == deflt ? deflt : x
delete!(s::OrderedSet, x) = (delete!(s.dict, x); s)

empty(s::OrderedSet{T}) where {T} = OrderedSet{T}()
copy(s::OrderedSet) = union!(empty(s), s)

empty!(s::OrderedSet{T}) where {T} = (empty!(s.dict); s)

emptymutable(s::OrderedSet{T}, ::Type{U}=T) where {T,U} = OrderedSet{U}()
copymutable(s::OrderedSet) = copy(s)

# NOTE: manually optimized to take advantage of OrderedDict representation
function iterate(s::OrderedSet)
    s.dict.ndel > 0 && rehash!(s.dict)
    length(s.dict.keys) < 1 && return nothing
    return (s.dict.keys[1], 2)
end
function iterate(s::OrderedSet, i)
    length(s.dict.keys) < i && return nothing
    return (s.dict.keys[i], i+1)
end

# lazy reverse iteration
function iterate(rs::Iterators.Reverse{<:OrderedSet}, i = length(rs.itr))
    s = rs.itr
    i < 1 && return nothing
    return (s.dict.keys[i], i-1)
end

pop!(s::OrderedSet) = pop!(s.dict)[1]
popfirst!(s::OrderedSet) = popfirst!(s.dict)[1]

==(l::OrderedSet, r::OrderedSet) = (length(l) == length(r)) && (l <= r)
<(l::OrderedSet, r::OrderedSet) = (length(l) < length(r)) && (l <= r)
<=(l::OrderedSet, r::OrderedSet) = issubset(l, r)

function filter!(f::Function, s::OrderedSet)
    for x in s
        if !f(x)
            delete!(s, x)
        end
    end
    return s
end

function hash(s::OrderedSet, h::UInt)
    h = hash(orderedset_seed, h)
    s.dict.ndel > 0 && rehash!(s.dict)
    hash(s.dict.keys, h)
end

# Deprecated functionality, see
# https://github.com/JuliaCollections/DataStructures.jl/pull/180#issuecomment-400269803

function getindex(s::OrderedSet, i::Int)
    Base.depwarn("indexing is deprecated for OrderedSet, please rewrite your code to use iteration", :getindex)
    s.dict.ndel > 0 && rehash!(s.dict)
    return s.dict.keys[i]
end

function lastindex(s::OrderedSet)
    Base.depwarn("indexing is deprecated for OrderedSet, please rewrite your code to use iteration", :lastindex)
    s.dict.ndel > 0 && rehash!(s.dict)
    return lastindex(s.dict.keys)
end

function nextind(::OrderedSet, i::Int)
    Base.depwarn("indexing is deprecated for OrderedSet, please rewrite your code to use iteration", :lastindex)
    return i + 1  # Needed on 0.7 to mimic array indexing.
end

function keys(s::OrderedSet)
    Base.depwarn("indexing is deprecated for OrderedSet, please rewrite your code to use iteration", :lastindex)
    s.dict.ndel > 0 && rehash!(s.dict)
    return 1:length(s)
end

# OrderedCollections.jl

This package implements associative containers that preserve the order of insertion:

-   OrderedDict
-   OrderedSet
-   LittleDict


## OrderedSets

`OrderedSets` are sets whose entries have a particular order.
Order refers to *insertion order*, which allows deterministic
iteration over the set:

```julia
using Base.MathConstants
s = OrderedSet((π,e,γ,catalan,φ))
for x in s
   println(x)
end
#> π = 3.1415926535897...
#> ℯ = 2.7182818284590...
#> γ = 0.5772156649015...
#> catalan = 0.9159655941772...
#> φ = 1.6180339887498...
```
All `Set` operations are available for OrderedSets.

Note that to create an OrderedSet of a particular type, you must
specify the type in curly-braces:

```julia
# create an OrderedSet of Strings
strs = OrderedSet{AbstractString}()
```

## OrderedDicts
Similarly, `OrderedDict` are simply dictionaries whose entries have a particular
order.
```julia
d = OrderedDict{Char,Int}()
for c in 'a':'d'
    d[c] = c-'a'+1
end
for x in d
   println(x)
end
#> 'a' => 1
#> 'b' => 2
#> 'c' => 3
#> 'd' => 4
```
The insertion order is conserved when iterating on the dictionary itself,
its keys (through `keys(d)`), or its values (through `values(d)`).
All standard `Associative` and `Dict` functions are available for `OrderedDicts`

## LittleDict
```julia
d = LittleDict{Char,Int}()
for c in 'a':'d'
    d[c] = c-'a'+1
end
for x in d
   println(x)
end
#> 'a' => 1
#> 'b' => 2
#> 'c' => 3
#> 'd' => 4
```
The `LittleDict` acts similarly to the `OrderedDict`.
However for small collections it is much faster.
Indeed the preceeding example (with the io redirected to `devnull`), runs 4x faster in the `LittleDict` version as the earlier `OrderedDict` version.

```@docs
OrderedDict
OrderedSet
LittleDict
LittleSet
freeze
OrderedCollections.isordered
```
